'Batch file to Copy and Convert ML Raw footage to a specified location using drag and drop
' By Val Gameiro
Option Explicit

Dim arg, newarg(), projname, destfolder, subfolder, wshShell, i, response, objShell, objFolder, objFolderItem
Dim bullit, intIndex, argcount
Set arg = WScript.Arguments
bullit = Chr(10) & "   " & Chr(149) & " "
argcount = arg.Count

' Input Magazine name for EXIFTOOL - Create folder in Browse Folder dialog (Folder = Project)
projname = UserInput( "Enter Magazine Name for EXIFTOOL tagging (e.g. Test Shoot Mag A): " )
If projname = "" Then WScript.Quit

' Select where to store the files and conversions
Const DESKTOP = &H10&
Set objShell = CreateObject("Shell.Application")
Set objFolder = objShell.Namespace(DESKTOP)
Set objFolderItem = objFolder.Self
'Wscript.Echo objFolderItem.Path
destfolder = BrowseFolder( "objFolderItem.Path", False )
If destfolder = "" Then WScript.Quit

' Select Conversion option
Do
    response = InputBox("Select conversion format:" & Chr(10) & bullit & "1) CinemaDNG (RAW2DNG)" & bullit & "2) GoPro CineForm .AVI compressed" & bullit & "4) Quit" & Chr(10), "Enter option number:")
    If response = "" Then WScript.Quit  'Detect Cancel
    If IsNumeric(response) Then Exit Do 'Detect value response.
    MsgBox "You must enter a numeric value.", 48, "Invalid Entry"
Loop
If response = 4 Then WScript.Quit
'MsgBox "The user chose :" & response, 64, "Yay!"

' Copy files and notify it's done, so user can remove card
Set wshShell = WScript.CreateObject ("WSCript.shell")
i = 0
ReDim newarg(argcount)
Dim components, objFileCopy, objFSO
Set objFSO = CreateObject("Scripting.FileSystemObject")

While i < argcount
	components = Split(arg(i), "\")
	subfolder = "\" & Left(components(Ubound(components)), InStrRev(components(Ubound(components)), ".")-1)
	' Create FileSystemObject. So we can apply .createFolder method
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	' Here is the key line Create a Folder, using strDirectory 
	If Not objFSO.FolderExists(destfolder & subfolder) Then
		Set objFolder = objFSO.CreateFolder(destfolder & subfolder)
	End If
	'MsgBox "xcopy """ & arg(i) & """ " & """" & destfolder & """" & " /V /Q"
	wshshell.Run "xcopy """ & arg(i) & """ " & """" & destfolder & subfolder & """" & " /V /Q", 4, True
	'MsgBox "Error: " & Err.Number
	If Err.Number = 0 Then	
		newarg(i) = destfolder & subfolder & "\" & components(Ubound(components))
		'Wscript.Echo "File name: " & newarg(i)
		' Uncomment the next line to automatically delete the source file
	End If
	i = i + 1
Wend
Msgbox "Files have been copied, you can now erase and remove the card/media"

' Convert files
' Include option to put DNGs in Subfolder, or same folder as .RAW
i = 0
Dim fullfilename, filename, tofile, filepath
While i < argcount
	Select Case response
		Case 1 ' Using RAW2DNG
			components = Split(newarg(i), "\")
			fullfilename = components(Ubound(components)) 'including .ext
			filename = Left(fullfilename, InStrRev(fullfilename, ".")-1)
			'filepath = Replace(newarg(i), fullfilename, "")
			'MsgBox "md """ & filepath & "DNG"""
			tofile = Replace(newarg(i), fullfilename, filename)
			'wshshell.Run "md """ & filepath & "\DNG"""
			'tofile = Replace(newarg(i), fullfilename, "DNG\" & filename) 
			'MsgBox fullfilename & " / " & tofile & "-"""
			'MsgBox "raw2dng """ & newarg(i) & """ " & """" & tofile & "-"""
			'wshshell.Run "%comspec% /k " & "raw2dng """ & newarg(i) & """ " & """" & tofile & "-"""
			wshshell.Run "raw2dng """ & newarg(i) & """ " & """" & tofile & "-""", 4, True
			'MsgBox "exiftool -v1 -ReelName=" & """" & projname & """" & " *.DNG -overwrite_original_in_place"
			wshshell.Run "exiftool -ReelName=" & """" & projname & """" & " *.DNG -overwrite_original_in_place", 4, True
		Case 2 ' Using RAW2CF from CineForm Tools 422
			components = Split(newarg(i), "\")
			fullfilename = components(Ubound(components)) 'including .ext
			filename = Left(fullfilename, InStrRev(fullfilename, ".")-1)
			'filepath = Replace(newarg(i), fullfilename, "")
			'MsgBox "md """ & filepath & "DNG"""
			tofile = Replace(newarg(i), fullfilename, filename)
			'MsgBox fullfilename & " / " & tofile & "-"""
			'MsgBox "raw2gpcf """ & newarg(i) & """ " & """" & tofile & ".avi"""
			wshshell.Run "raw2gpcf """ & newarg(i) & """ " & """" & tofile & ".avi""", 4, True
	End Select
	i = i + 1
Wend

' House cleaning
Set arg = Nothing
WScript.quit

Function BrowseFolder( myStartLocation, blnSimpleDialog )
' This function generates a Browse Folder dialog
' and returns the selected folder as a string.
'
' Arguments:
' myStartLocation   [string]  start folder for dialog, or "My Computer", or
'                             empty string to open in "Desktop\My Documents"
' blnSimpleDialog   [boolean] if False, an additional text field will be
'                             displayed where the folder can be selected
'                             by typing the fully qualified path
'
' Returns:          [string]  the fully qualified path to the selected folder
'
' Based on the Hey Scripting Guys article
' "How Can I Show Users a Dialog Box That Only Lets Them Select Folders?"
' http://www.microsoft.com/technet/scriptcenter/resources/qanda/jun05/hey0617.mspx
'
' Function written by Rob van der Woude
' http://www.robvanderwoude.com
    Const MY_COMPUTER   = &H11&
    Const WINDOW_HANDLE = 0 ' Must ALWAYS be 0

    Dim numOptions, objFolder, objFolderItem
    Dim objPath, objShell, strPath, strPrompt

    ' Set the options for the dialog window
    strPrompt = "Select a folder to store files:"
    If blnSimpleDialog = True Then
        numOptions = 0      ' Simple dialog
    Else
        numOptions = &H10&  ' Additional text field to type folder path
    End If
    
    ' Create a Windows Shell object
    Set objShell = CreateObject( "Shell.Application" )

    ' If specified, convert "My Computer" to a valid
    ' path for the Windows Shell's BrowseFolder method
    If UCase( myStartLocation ) = "MY COMPUTER" Then
        Set objFolder = objShell.Namespace( MY_COMPUTER )
        Set objFolderItem = objFolder.Self
        strPath = objFolderItem.Path
    Else
        strPath = myStartLocation
    End If

    Set objFolder = objShell.BrowseForFolder( WINDOW_HANDLE, strPrompt, _
                                              numOptions, strPath )

    ' Quit if no folder was selected
    If objFolder Is Nothing Then
        BrowseFolder = ""
        Exit Function
    End If

    ' Retrieve the path of the selected folder
    Set objFolderItem = objFolder.Self
    objPath = objFolderItem.Path

    ' Return the path of the selected folder
    BrowseFolder = objPath
End Function

Function UserInput( myPrompt )
' This function prompts the user for some input.
' When the script runs in CSCRIPT.EXE, StdIn is used,
' otherwise the VBScript InputBox( ) function is used.
' myPrompt is the the text used to prompt the user for input.
' The function returns the input typed either on StdIn or in InputBox( ).
' Written by Rob van der Woude
' http://www.robvanderwoude.com
    ' Check if the script runs in CSCRIPT.EXE
    If UCase( Right( WScript.FullName, 12 ) ) = "\CSCRIPT.EXE" Then
        ' If so, use StdIn and StdOut
        WScript.StdOut.Write myPrompt & " "
        UserInput = WScript.StdIn.ReadLine
    Else
        ' If not, use InputBox( )
        UserInput = InputBox( myPrompt )
    End If
End Function